const dbConnection = require("../db/connection");
require("./globalfuntions.controller");
const { logger_data, logger_msg } = require('../config/utils');

familia_nivel_3_Controller = {};
let msgLog = [];



familia_nivel_3_Controller.loadpage = (req, res) => {
    res.send("API familiaNivel3");
}

familia_nivel_3_Controller.familia_nivel_3_list = (req, res) => {
    const query = "SELECT fn3.*, fn2.descripcion AS idFamiliaNivel2Desc, fn1.descripcion AS idFamiliaNivel1Desc, n.descripcion AS idNomenclaturaDesc, c.descripcion AS idCentrosCostoDesc FROM familiaNivel3 fn3 LEFT JOIN familiaNivel1 fn1 ON fn3.idFamiliaNivel2 = fn1.id LEFT JOIN familiaNivel2 fn2 ON fn3.idFamiliaNivel2 = fn2.id LEFT JOIN nomenclatura n ON fn3.idNomenclatura = n.id LEFT JOIN centrosCosto c ON fn3.idCentrosCosto = c.id WHERE fn3.idEmpresas=1;";
    dbConnection.connectionDB.query(query, (error, response, results) => {
        if (error) {
            console.log(error);
            const status = globalFunctions.statusMsg(0);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        } else if (response) {
            res.json(response);
        } else {
            const status = globalFunctions.statusMsg(4);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        }
    });
}

familia_nivel_3_Controller.familia_nivel_3_detail = (req, res) => {
    const f = req.body;
    const query = "SELECT * FROM familiaNivel3 WHERE idFamiliaNivel2 = ? AND idEmpresas = ?;";
    dbConnection.connectionDB.query(query, [f.idFamiliaNivel2, f.idEmpresas], (error, response, results) => {
        if (error) {
            console.log(error);
            const status = globalFunctions.statusMsg(0);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        } else if (response) {
            res.json(response);
        } else {
            const status = globalFunctions.statusMsg(4);
            msgLog.length = 0;
            msgLog.push(status);
            res.json(msgLog);
            msgLog.length = 0;
        }
    });
}

// elimina un dato de la base
familia_nivel_3_Controller.familia_nivel_3_delete = (req, res) => {
    const familia_nivel_3 = req.body;
    if (!familia_nivel_3) {
        const status = globalFunctions.statusMsg(4);
        msgLog.length = 0;
        msgLog.push(status);
        res.json(msgLog);
        msgLog.length = 0;
    } else {
        console.table(familia_nivel_3);
        const query = "DELETE FROM familiaNivel3 WHERE id = ? and idEmpresas = ?;";
        dbConnection.connectionDB.beginTransaction((err) => {
            if (err) {
                console.error("TRANSACTION ERROR :>> ", err);
            } else {
                dbConnection.connectionDB.query(query, [familia_nivel_3.id, familia_nivel_3.idEmpresas],
                    (error, response, result) => {
                        if (error) {
                            dbConnection.connectionDB.rollback(() => {
                                console.log("QUERY > ROLLBACK ERROR 'DELETE' familiaNivel3 :>> ", error);
                                const status = globalFunctions.statusMsg(0);
                                msgLog.length = 0;
                                msgLog.push(status);
                                res.json(msgLog);
                                msgLog.length = 0;
                            });
                        } else if (response) {
                            console.log("QUERY RESPONSE :>> ");
                            console.log(response);
                            /*
							console.log("QUERY RESULT :>> ");
							console.log(result);
                            */
                            dbConnection.connectionDB.commit((err) => {
                                if (err) {
                                    dbConnection.connectionDB.rollback(() => {
                                        console.log(
                                            "COMMIT ERROR ROLLBACK 'DELETE' familiaNivel3 :>> ",
                                            err,
                                        );
                                        const status = globalFunctions.statusMsg(0);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    });
                                } else {
                                    const status = globalFunctions.statusMsg(1);
                                    msgLog.length = 0;
                                    msgLog.push(status);
                                    res.json(msgLog);
                                    msgLog.length = 0;
                                }
                            });
                        } else {
                            const status = globalFunctions.statusMsg(4);
                            msgLog.length = 0;
                            msgLog.push(status);
                            res.json(msgLog);
                            msgLog.length = 0;
                        }
                    },
                );
            }
        });
    }
}

// crear un dato en la base
familia_nivel_3_Controller.familia_nivel_3_create = (req, res) => {
    const familia_nivel_3 = req.body;
    console.table(familia_nivel_3);
    const query =
        "INSERT INTO familiaNivel3 (descripcion, idFamiliaNivel2, idNomenclatura, idCentrosCosto, idEmpresas, created_at) VALUES( ?, ?, ?, ?, ?, CURRENT_TIMESTAMP());";

    dbConnection.connectionDB.beginTransaction((err) => {
        if (err) {
            console.error("TRANSACTION ERROR :>> ", err);
        } else {
            dbConnection.connectionDB.query(
                query, [
                    familia_nivel_3.descripcion,
                    familia_nivel_3.idFamiliaNivel2,
                    familia_nivel_3.idNomenclatura,
                    familia_nivel_3.idCentrosCosto,
                    familia_nivel_3.idEmpresas,
                ],
                (error, response, result) => {
                    if (error) {
                        dbConnection.connectionDB.rollback(() => {
                            console.log("QUERY > ROLLBACK ERROR INSERT familiaNivel3 :>> ", error);
                            const status = globalFunctions.statusMsg(0);
                            msgLog.length = 0;
                            msgLog.push(status);
                            res.json(msgLog);
                            msgLog.length = 0;
                        });
                    } else if (response) {
                        dbConnection.connectionDB.commit((err) => {
                            if (err) {
                                dbConnection.connectionDB.rollback(() => {
                                    console.log(
                                        "COMMIT ERROR ROLLBACK INSERT familiaNivel3 :>> ",
                                        err,
                                    );
                                });
                            } else {
                                const status = globalFunctions.statusMsg(1);
                                msgLog.length = 0;
                                msgLog.push(status);
                                res.json(msgLog);
                                msgLog.length = 0;
                            }
                        });
                    }
                },
            );
        }
    });
};

familia_nivel_3_Controller.familia_nivel_3_update = (req, res) => {
    const familia_nivel_3 = req.body;

    if (!familia_nivel_3) {
        const status = gF.globalFunctions.statusMsg(4);
        msgLog.length = 0;
        msgLog.push(status);
        res.json(msgLog);
        msgLog.length = 0;
    } else {
        console.table(familia_nivel_3);
        const query = "UPDATE familiaNivel3 SET descripcion = ?, idFamiliaNivel2 = ?, idNomenclatura = ?, idCentrosCosto = ?, idEmpresas = ?, updated_at = CURRENT_TIMESTAMP() WHERE id = ?";

        dbConnection.connectionDB.beginTransaction((err) => {
            if (err) {
                console.error("TRANSACTION ERROR :>> ", err);
            } else {
                dbConnection.connectionDB.query(
                    query, [
                        familia_nivel_3.descripcion,
                        familia_nivel_3.idFamiliaNivel2,
                        familia_nivel_3.idNomenclatura,
                        familia_nivel_3.idCentrosCosto,
                        familia_nivel_3.idEmpresas,
                        familia_nivel_3.id
                    ],
                    (error, response, result) => {
                        if (error) {
                            dbConnection.connectionDB.rollback(() => {
                                console.log("QUERY > ROLLBACK ERROR UPDATE familiaNivel3 :>> ", error);
                                const status = globalFunctions.statusMsg(0);
                                msgLog.length = 0;
                                msgLog.push(status);
                                res.json(msgLog);
                                msgLog.length = 0;
                            });
                        } else if (response) {
                            console.log("QUERY RESULT :>> ");
                            console.log(result);
                            dbConnection.connectionDB.commit((err) => {
                                if (err) {
                                    dbConnection.connectionDB.rollback(() => {
                                        console.log(
                                            "COMMIT ERROR ROLLBACK UPDATE familiaNivel3 :>> ",
                                            err,
                                        );
                                    });
                                } else {
                                    const status = globalFunctions.statusMsg(1);
                                    msgLog.length = 0;
                                    msgLog.push(status);
                                    res.json(msgLog);
                                    msgLog.length = 0;
                                }
                            });
                        }
                    },
                );
            }
        });
    }
};

module.exports.familia_nivel_3_Controller = familia_nivel_3_Controller;