const dbConnection = require("../db/connection");

const fs = require("fs");

require("./globalfuntions.controller");

const { logger_data, logger_msg } = require('../config/utils');

global.__basedir = __dirname;

proveedoresController = {};

arrayLog = [];

let msgLog = [];
let counter = 0;

// * Carga la página del controlador.
proveedoresController.proveedores_loadpage = (req, res) => {
	globalFunctions.logger(logger_data(req), 'trace', logger_msg.loading);
	res.send("API proveedores");
};

// * Traer datos de la base de datos.
proveedoresController.proveedores_list = (req, res) => {
	const proveedor = req.body;
    console.table(proveedor);
	const query = "SELECT * FROM proveedores WHERE idEmpresas = ?;";
	dbConnection.connectionDB.query(query,[proveedor.idEmpresas], (error, results, response) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (results.length>0) {
			res.json(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};

proveedoresController.proveedores_create_post = (req, res) => {
	const proveedor = req.body;
    if (!proveedor) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		if (!proveedor.descripcion ||
			!proveedor.nitP ||
			!proveedor.nombreContacto ||
			!proveedor.emailContacto ||
			!proveedor.telefono ||
			!proveedor.idFormasPago ||
			!proveedor.idEmpresas) {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else {
            console.table(proveedor);
            const query = "INSERT INTO proveedores (descripcion,nitP,direccionP,nombreContacto,telefono,"+
                        "emailContacto,limiteCredito,diasCredito,idFormasPago,nombreChequeP,cuentaBancaria,nombreCuenta,idBanco,idTipoCuenta,idPequenoContribuyente,"+
                        "idNomenclatura,idCentrosCosto,observaciones,idEmpresas) VALUES (?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?);";
        
            dbConnection.connectionDB.beginTransaction((err) => {
                if (err) {
                    console.error("TRANSACTION ERROR :>> ", err);
                } else {
                    dbConnection.connectionDB.query(
                        query,
                        [
                            proveedor.descripcion,
                            proveedor.nitP,
                            proveedor.direccionP,
                            proveedor.nombreContacto,
                            proveedor.telefono,
                            proveedor.emailContacto,
							proveedor.limiteCredito,
                            proveedor.diasCredito,
							proveedor.idFormasPago,
                            proveedor.nombreChequeP,
                            proveedor.cuentaBancaria,
							proveedor.nombreCuenta,
							proveedor.idBanco,
							proveedor.idTipoCuenta,
                            proveedor.idPequenoContribuyente,
                            proveedor.idNomenclatura,
                            proveedor.idCentrosCosto,
                            proveedor.observaciones,
                            proveedor.idEmpresas
                        ],
                        (error, response, result) => {
                            if (error) {
                                dbConnection.connectionDB.rollback(() => {
                                    console.log("QUERY > ROLLBACK ERROR INSERT proveedor :>> ", error);
                                    const status = globalFunctions.statusMsg(0);
                                    msgLog.length = 0;
                                    msgLog.push(status);
                                    res.json(msgLog);
                                    msgLog.length = 0;
                                });
                            } else if (response) {
                                dbConnection.connectionDB.commit((err) => {
                                    if (err) {
                                        dbConnection.connectionDB.rollback(() => {
                                            console.log(
                                                "COMMIT ERROR ROLLBACK INSERT proveedor :>> ",
                                                err,
                                            );
                                        });
                                    } else {
                                        const status = globalFunctions.statusMsg(1);
                                        msgLog.length = 0;
                                        msgLog.push(status);
                                        res.json(msgLog);
                                        msgLog.length = 0;
                                    }
                                });
                            }
                        },
                    );
                }
            });
        }
    }
};

proveedoresController.proveedores_detail = (req, res) => {
	const proveedor = req.body;
	console.table(proveedor);
	const query = "SELECT * FROM proveedores WHERE id = ? AND idEmpresas = ?;"
	dbConnection.connectionDB.query(query, [proveedor.id,proveedor.idEmpresas], (error, response, results) => {
		if (error) {
			console.error(error);
			const status = globalFunctions.statusMsg(0);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		} else if (response) {
			res.json(response);
		} else {
			const status = globalFunctions.statusMsg(4);
			console.table(status);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
}

proveedoresController.proveedores_update_post = (req, res) => {
	const proveedor = req.body;
	if (!proveedor) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(proveedor);
		const query = "UPDATE proveedores SET descripcion = ?, nitp = ?, direccionP = ?,nombreContacto = ?,telefono = ?," + 
        "emailContacto = ?,limiteCredito = ?, diasCredito = ?, idFormasPago = ?,nombreChequeP = ?, cuentaBancaria = ?, nombreCuenta = ?, idBanco = ?, idTipoCuenta = ?, idPequenoContribuyente = ?,idNomenclatura = ?,idCentrosCosto = ?,observaciones = ? WHERE id = ? and idEmpresas = ?;";

		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(
					query,
					[
						proveedor.descripcion,
						proveedor.nitP,
						proveedor.direccionP,
						proveedor.nombreContacto,
						proveedor.telefono,
						proveedor.emailContacto,
						proveedor.limiteCredito,
						proveedor.diasCredito,
						proveedor.idFormasPago,
						proveedor.nombreChequeP,
						proveedor.cuentaBancaria,
						proveedor.nombreCuenta,
						proveedor.idBanco,
						proveedor.idTipoCuenta,
                        proveedor.idPequenoContribuyente,
                        proveedor.idNomenclatura,
                        proveedor.idCentrosCosto,
						proveedor.observaciones,
                        proveedor.id,
						proveedor.idEmpresas
					],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR UPDATE proveedores :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESULT :>> ");
							console.log(response);
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK UPDATE proveedores :>> ",
											err,
										);
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						}
					},
				);
			}
		});
	}
}

proveedoresController.proveedores_delete_post = (req, res) => {
	const proveedor = req.body;
	if (!proveedor) {
		const status = globalFunctions.statusMsg(4);
		msgLog.length = 0;
		msgLog.push(status);
		res.json(msgLog);
		msgLog.length = 0;
	} else {
		console.table(proveedor);
		const query = "DELETE FROM proveedores WHERE id = ? and idEmpresas = ?;";
		dbConnection.connectionDB.beginTransaction((err) => {
			if (err) {
				console.error("TRANSACTION ERROR :>> ", err);
			} else {
				dbConnection.connectionDB.query(query, [proveedor.id,proveedor.idEmpresas],
					(error, response, result) => {
						if (error) {
							dbConnection.connectionDB.rollback(() => {
								console.log("QUERY > ROLLBACK ERROR 'DELETE' proveedores :>> ", error);
								const status = globalFunctions.statusMsg(0);
								msgLog.length = 0;
								msgLog.push(status);
								res.json(msgLog);
								msgLog.length = 0;
							});
						} else if (response) {
							console.log("QUERY RESPONSE :>> ");
							console.log(response);
                            /*
							console.log("QUERY RESULT :>> ");
							console.log(result);
                            */
							dbConnection.connectionDB.commit((err) => {
								if (err) {
									dbConnection.connectionDB.rollback(() => {
										console.log(
											"COMMIT ERROR ROLLBACK 'DELETE' proveedores :>> ",
											err,
										);
										const status = globalFunctions.statusMsg(0);
										msgLog.length = 0;
										msgLog.push(status);
										res.json(msgLog);
										msgLog.length = 0;
									});
								} else {
									const status = globalFunctions.statusMsg(1);
									msgLog.length = 0;
									msgLog.push(status);
									res.json(msgLog);
									msgLog.length = 0;
								}
							});
						} else {
							const status = globalFunctions.statusMsg(4);
							msgLog.length = 0;
							msgLog.push(status);
							res.json(msgLog);
							msgLog.length = 0;
						}
					},
				);
			}
		});
	}
}

//* Trae una lista con la informacion del proveedor asi como el saldo que tiene con dicho proveedor.
proveedoresController.proveedores_creditos = (req, res) => {
    const compras = req.body;
	console.table(compras);
	const query = "SELECT * FROM proveedores LEFT JOIN cxp ON idProveedores = proveedores.id WHERE proveedores.id = ? ORDER BY cxp.id DESC LIMIT 1;";
	dbConnection.connectionDB.query(query,[compras.idProveedores], (error, results) => {
		if (error) throw error;
		if (results.length > 0) {
			res.json(results);
		} else {
			const status = globalFunctions.statusMsg(4);
			msgLog.length = 0;
			msgLog.push(status);
			res.json(msgLog);
			msgLog.length = 0;
		}
	});
};


module.exports.proveedoresController = proveedoresController;
